/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 *
 *******************************************************************************
 *
 * $Id: MetadataItemSourceSupport.java,v d60681e7fc1d 2009/09/17 23:59:23 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.metadata.spi;

import javax.annotation.Nonnull;
import it.tidalwave.metadata.Metadata.StorageType;

/*******************************************************************************
 *
 * 
 * @author  Fabrizio Giudici
 * @version $Id: MetadataItemSourceSupport.java,v d60681e7fc1d 2009/09/17 23:59:23 fabrizio $
 *
 ******************************************************************************/
public abstract class MetadataItemSourceSupport<Item> implements MetadataItemSource<Item>
  {
    @Nonnull 
    private final Class<Item> itemClass;
    
    @Nonnull 
    private final String name;
    
    @Nonnull 
    private final StorageType type;

    /***************************************************************************
     *
     * 
     **************************************************************************/
    public MetadataItemSourceSupport (@Nonnull final Class<Item> itemClass,
                                      @Nonnull final String name, 
                                      @Nonnull final StorageType type) 
      {
        this.itemClass = itemClass;
        this.name = name;
        this.type = type;
      }
    
    /***************************************************************************
     *
     * {@inheritDoc}
     * 
     **************************************************************************/
    @Nonnull 
    public final Class<Item> getItemClass()
      {
        return itemClass;
      }
    
    /***************************************************************************
     *
     * {@inheritDoc}
     * 
     **************************************************************************/
    @Nonnull 
    public final String getName()
      {
        return name;
      }
    
    /***************************************************************************
     *
     * {@inheritDoc}
     * 
     **************************************************************************/
    @Nonnull 
    public final StorageType getType()
      {
        return type;
      }
  }
